package nckd.wnq01.wnq.scm.plugin.form;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.sdk.plugin.Plugin;

import java.util.ArrayList;
import java.util.EventObject;
import java.util.List;

/**
 * 动态表单插件
 */
public class RebatePolicyFormPlugin extends AbstractFormPlugin implements Plugin {

    private String[] fields = new String[]{"nckd_amountratemin","nckd_amountratemax","nckd_qtyratemin","nckd_qtyratemax","nckd_amountmin","nckd_amountmax","nckd_qtymin","nckd_qtymax"};

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
    }

    @Override
    public void afterBindData(EventObject e) {
        super.afterBindData(e);
        for(String field : fields) {
            this.getView().setVisible(false, field);
        }
        DynamicObject newValue = (DynamicObject) this.getModel().getValue("nckd_policytype");
        if(newValue != null) {
            newValue = BusinessDataServiceHelper.loadSingle(newValue.getPkValue(), "nckd_policytype");
            DynamicObject judgment = newValue.getDynamicObject("nckd_judgmentcriteria");
            String name = judgment.getString("name");
            setFieldStatus(name);
        }
    }

    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
        String key = e.getProperty().getName();
        if("nckd_policytype".equals(key)) {
            DynamicObject newValue = (DynamicObject) e.getChangeSet()[0].getNewValue();
            if(newValue == null) {
                List list = new ArrayList();
                list.add("999999");
                setFieldVisible(list);
            }
            else {
                newValue = BusinessDataServiceHelper.loadSingle(newValue.getPkValue(), "nckd_policytype");
                DynamicObject judgment = newValue.getDynamicObject("nckd_judgmentcriteria");
                String name = judgment.getString("name");
                setFieldStatus(name);
            }
        }
    }

    public void setFieldStatus (String name) {
        List fieldsList = new ArrayList<String>();
        switch (name) {
            case "金额达成率" :
                fieldsList.add("nckd_amountratemin");
                fieldsList.add("nckd_amountratemax");
                break;
            case "数量达成率" :
                fieldsList.add("nckd_qtyratemin");
                fieldsList.add("nckd_qtyratemax");
                break;
            case "金额阶梯" :
                fieldsList.add("nckd_amountmin");
                fieldsList.add("nckd_amountmax");
                break;
            case "数量阶梯" :
                fieldsList.add("nckd_qtymin");
                fieldsList.add("nckd_qtymax");
                break;
        }
        setFieldVisible(fieldsList);
    }

    public void setFieldVisible (List fieldsList) {
        for(String field : fields) {
            if(fieldsList.contains(field)) {
                this.getView().setVisible(true, field);
            }
            else {
                this.getView().setVisible(false, field);
            }
        }

    }



}